/******************************************************************************
 glauxiliar.h---------------------------------------------------------------------
 Este arquivo contm informaes para execuo de funes extras do sistemas,
 ou de funes que se repetem e so grandes de mais para o arquivo primrio.
 *****************************************************************************/


#pragma once




#include <stdlib.h>
#include <GL/glut.h>
#include "define.h"
#include "cores.h"
#include "matriz.h"



#define eixoX(t, r) (((r)*cos((t)*RADIANO))/RAIO)
#define eixoY(t, r) (((r)*sin((t)*RADIANO))/RAIO)
#define azToPol(x) ((450 - x)%360)




/* Funes auxiliares (substituir por macros de compilao, quando possvel) */
//GLfloat eixoX(double, double); // Calcula o eixo X, dado ngulo e Raio
int Aprox(double); // Gera o valor arredondado de um Nmero




/* Funes auxiliares de Inicializao e similares */
void getLineColor(int, int); // Dada as coordenadas de um ponto do Bolacha, diz qual ser sua cor
void getNewColor(int, int, int); // Dada as coordenadas de um ponto do Bolacha, diz qual ser sua cor
void inciaMatriz(int, char *[]); // Inicia o objeto matriz com os dados do arquivo
void ordenaVetor(); // Ordena o vetor Pontos para gerao dos Cortes
void ordenaVetorReta(); // Ordena o vetor Pontos para gerao dos Graficos
void vetorDados(); // Inicializa os calculos relativos ao vetor Pontos e  variaveis relacionadas



/* Objetos */
Matriz matriz; // Objeto matriz




/* Controle de ajustes devido ao Zoom */
GLfloat xMin = 2.0; // O menor valor de x do intervalo
GLfloat xMax = -2.0; // O maior valor de x do intervalo 
GLfloat yMin = 2.0; // O menor valor de y do intervalo
GLfloat yMax = -2.0; // O maior valor de x do intervalo
GLfloat xZero = 0.0; // O novo x=0, relativo ao Zoom
GLfloat yZero = 0.0; // O novo y=0, relativo ao Zoom
GLfloat xIntervalo; // A distncia entre xMin e xMax
GLfloat yIntervalo; // A distncia entre yMin e yMax


int mXI = 0; // 
int mYI = 0; //
bool isLinha = true; // verdadeiro se for linha, falso se for coluna.
unsigned int abertura = 0; // Quantidade de pontos presentes na seleo





/* Suporte para BOX de Seleo */
bool tracking = false; /* left button down, sense motion */
static float xSelecaoInicial = 0;
static float ySelecaoInicial = 0;
static float xSelecaoAtual = 0;
static float ySelecaoAtual = 0;




static float xSelecaoInicialOld = 0;
static float ySelecaoInicialOld = 0;
static float xSelecaoAtualOld = 0;
static float ySelecaoAtualOld = 0;





struct fig {
	int kind; // 1 para retangulo, 2 para fatia de pizza
	float x0;
	float y0;
	float x1;
	float y1;
} figure;




unsigned int pontos[2][2] = {0, 0, 359, 1998};
/*	pontos[0][0] - Angulo Inicial (Azimutal?)
	pontos[0][1] - Raio Inicial
	pontos[1][0] - Angulo Final (Azimutal?)
	pontos[1][1] - Raio Final
*/




unsigned int retaPontos[2][2] = {0, 0, 359, 1998};
/*	pontos[0][0] - Angulo Inicial (Azimutal?)
	pontos[0][1] - Raio Inicial
	pontos[1][0] - Angulo Final (Azimutal?)
	pontos[1][1] - Raio Final
*/




unsigned int selecao[3];
/*
	selecao[0] - linha/coluna inicial
	selecao[1] - linha/coluna final
	selecao[2] - coluna/linha fixa
*/




/* Controle de Zoom */
GLfloat escalaGlobal = 1.0; // a escala global pela qual X e Y sero ajustados para o Zoom
double quadradoZoom[2];





/* Maquina de Estados */
enum EstadosPossiveis { ESPERA, SELECIONA_FATIA, EXIBE_ZOOM, SELECIONA_ZOOM, SELECIONA_ZOOM_DE_CORTE, EXIBE_FATIA, SELECIONA_GRAFICO, EXIBE_GRAFICO, SELECIONA_CORTE_DE_ZOOM, SELECIONA_CENTRO, SELECIONA_NUMEROS, EXIBE_NUMEROS }; // Estados possveis da mquina de estados do programa
EstadosPossiveis estado = ESPERA, estadoAnterior = ESPERA, estadoTemporario; // Ponteiro atual da maquina de estado
/* Significado de Cada Estado
 *	SELECIONA_CORTE_DE_ZOOM: fazer corte a partir de zoom, no implementado corretamente, ento, nunca  chamado

 *	ESPERA: Estado onde o programa inicia. Exibe a Bolacha inteira, o mouse no faz nada.
 
 *	EXIBE_GRAFICO: Estado de Espera, exibindo grfico de um corte
 *	EXIBE_FATIA:
 *	EXIBE_NUMEROS: Estado de Espera, exibindo os valores numricos em formato de tabela
 *	EXIBE_ZOOM: Estado de Espera, mas com imagem ampliada

 *	SELECIONA_CENTRO: Espera pelo clique do mouse no novo centro da imagem.
 *	SELECIONA_GRAFICO: Espera seleo da reta do grfico via mouse
 *	SELECIONA_FATIA: Esperando que o usuario escolha os pontos da fatia de Pizza
 *	SELECIONA_NUMEROS:
 *	SELECIONA_ZOOM: Esperando pelo usuario escolher uma regio de zoom
 *	SELECIONA_ZOOM_DE_CORTE:
 */






enum lugarCidade { BRU, PPR, UNK };
lugarCidade lugar = UNK;




enum coloridoEscolha {COR_MAXIMO, COR_MEDIO, COR_MINIMO, COR_BRILHO};
coloridoEscolha coresSuave = COR_MEDIO;




int Aprox(double d) {
	return(int)(d + 0.5);
} // int Aprox(double d) 





void getLineColor(int i, int j) {
	int cor_tabela;
	double cor = matriz.getTabela(i, j);



	float r1, r2, g1, g2, b1, b2;
	float v1 = 0.0, v2 = 0.0;
	int tmp;
	switch (coresSuave) {
		case COR_MAXIMO:
			


			if (cor >= -12.5 && cor < 65.0) {
				v1 = (cor+12.5)/2.5;
				cor_tabela = Aprox((cor+12.5)/2.5);
				v1 = (v1 - cor_tabela)/2.5;
				
				if (v1 < 0) {
					v1 = 1.0 - v1;
					cor_tabela = cor_tabela - 1;
					if (cor_tabela < 0)
						cor_tabela = 0;
					}



				v2 = 1-v1;



				tmp = cores[cor_tabela+1].R;
				tmp = tmp<0?tmp+256:tmp;
				r1 = v1*tmp/255.0;
				tmp = cores[cor_tabela+1].G;
				tmp = tmp<0?tmp+256:tmp;
				g1 = v1*tmp/255.0;
				tmp = cores[cor_tabela+1].B;
				tmp = tmp<0?tmp+256:tmp;
				b1 = v1*tmp/255.0;
				tmp = cores[cor_tabela].R;
				tmp = tmp<0?tmp+256:tmp;
				r2 = v2*tmp/255.0;
				tmp = cores[cor_tabela].G;
				tmp = tmp<0?tmp+256:tmp;
				g2 = v2*tmp/255.0;
				tmp = cores[cor_tabela].B;
				tmp = tmp<0?tmp+256:tmp;
				b2 = v2*tmp/255.0;




				glColor3f(r1+r2, g1+g2, b1+b2);


			} // if(cor > -20.0) 
			else if (cor >= 65.0) {


				v1 = (cor-65.0)/35.0;
				if (v1 > 1.0) v1 = 1.0;
				v2 = 1.0-v1;




				tmp = cores[32].R;
				tmp = tmp<0?tmp+256:tmp;
				r1 = v1*tmp/255.0;
				tmp = cores[32].G;
				tmp = tmp<0?tmp+256:tmp;
				g1 = v1*tmp/255.0;
				tmp = cores[32].B;
				tmp = tmp<0?tmp+256:tmp;
				b1 = v1*tmp/255.0;
				tmp = cores[31].R;
				tmp = tmp<0?tmp+256:tmp;
				r2 = v2*tmp/255.0;
				tmp = cores[31].G;
				tmp = tmp<0?tmp+256:tmp;
				g2 = v2*tmp/255.0;
				tmp = cores[31].B;
				tmp = tmp<0?tmp+256:tmp;
				b2 = v2*tmp/255.0;



				glColor3f(r1+r2, g1+g2, b1+b2);



				}
			else {


				glColor3f(0.0, 1.0, 1.0);


			} // else
			break;
		case COR_MEDIO:
			if(cor >= -12.5) {


				cor_tabela = Aprox((cor+12.5)/2.5);
				glColor3ub(cores[cor_tabela].R, cores[cor_tabela].G, cores[cor_tabela].B);


			} // if(cor > -20.0) 
			else {


				glColor3f(0.0, 1.0, 1.0);


			} // else
			break;
		case COR_MINIMO:


			if(cor >= -12.5) {



				if (cor < 0.0 ) 
					glColor3f(0.0, 1.0, 1.0);
				else if (cor < 25.0 )
					glColor3f(0.0, 1.0, 0.0);
				else if (cor < 45.0)
					glColor3f(1.0, 1.0, 0.0);
				else if (cor < 60.0)
					glColor3f(1.0, 0.0, 0.0);
				else
					glColor3f(1.0, 0.0, 1.0);


			} // if(cor > -20.0) 


			else {
				glColor3f(0.0, 1.0, 1.0);
			} // else
			break;
		case COR_BRILHO:


			if(cor >= -12.5) {
				cor = cor + 12.5;
				cor = cor/65;
				if (cor > 1.0)
					cor = 1.0;
				glColor3f(cor, cor, cor);
				}
			else {
				glColor3f(0.0, 0.0, 0.0);
			} // else


			break;
	}
	return;


} // void getLineColor(int i, int j)





void getNewColor(int sizeR, int i, int j) {


	int cor_tabela;
	float cor;

	if (sizeR == 1)
		cor = matriz.getTabela(i, j);
	else if (sizeR == 2)
		cor = matriz.getTabelaMenor2(i, j);
	else
		cor = matriz.getTabelaMenor4(i, j);




	float r1, r2, g1, g2, b1, b2;
	float v1 = 0.0, v2 = 0.0;
	int tmp;
	switch (coresSuave) {
		case COR_MAXIMO:
			



			if (cor >= -12.5 && cor < 65.0) {
				v1 = (cor+12.5)/2.5;
				cor_tabela = Aprox((cor+12.5)/2.5);
				v1 = (v1 - cor_tabela)/2.5;
				
				if (v1 < 0) {
					v1 = 1.0 - v1;
					cor_tabela = cor_tabela - 1;
					if (cor_tabela < 0)
						cor_tabela = 0;
					}




				v2 = 1-v1;



				tmp = cores[cor_tabela+1].R;
				tmp = tmp<0?tmp+256:tmp;
				r1 = v1*tmp/255.0;
				tmp = cores[cor_tabela+1].G;
				tmp = tmp<0?tmp+256:tmp;
				g1 = v1*tmp/255.0;
				tmp = cores[cor_tabela+1].B;
				tmp = tmp<0?tmp+256:tmp;
				b1 = v1*tmp/255.0;
				tmp = cores[cor_tabela].R;
				tmp = tmp<0?tmp+256:tmp;
				r2 = v2*tmp/255.0;
				tmp = cores[cor_tabela].G;
				tmp = tmp<0?tmp+256:tmp;
				g2 = v2*tmp/255.0;
				tmp = cores[cor_tabela].B;
				tmp = tmp<0?tmp+256:tmp;
				b2 = v2*tmp/255.0;



				glColor3f(r1+r2, g1+g2, b1+b2);


			} // if(cor > -20.0) 
			else if (cor >= 65.0) {


				v1 = (cor-65.0)/35.0;
				if (v1 > 1.0) v1 = 1.0;
				v2 = 1.0-v1;




				tmp = cores[32].R;
				tmp = tmp<0?tmp+256:tmp;
				r1 = v1*tmp/255.0;
				tmp = cores[32].G;
				tmp = tmp<0?tmp+256:tmp;
				g1 = v1*tmp/255.0;
				tmp = cores[32].B;
				tmp = tmp<0?tmp+256:tmp;
				b1 = v1*tmp/255.0;
				tmp = cores[31].R;
				tmp = tmp<0?tmp+256:tmp;
				r2 = v2*tmp/255.0;
				tmp = cores[31].G;
				tmp = tmp<0?tmp+256:tmp;
				g2 = v2*tmp/255.0;
				tmp = cores[31].B;
				tmp = tmp<0?tmp+256:tmp;
				b2 = v2*tmp/255.0;



				glColor3f(r1+r2, g1+g2, b1+b2);


				}
			else {


				glColor3f(0.6, 0.6, 0.6);


			} // else
			break;
		case COR_MEDIO:


			if(cor >= -12.5) {
				cor_tabela = Aprox((cor+12.5)/2.5);
				glColor3ub(cores[cor_tabela].R, cores[cor_tabela].G, cores[cor_tabela].B);
			} // if(cor > -20.0) 

			else {
				glColor3f(0.6, 0.6, 0.6);
			} // else
			break;
		case COR_MINIMO:



			if(cor >= -12.5) {
				if (cor < 0.0 ) 
					glColor3f(0.0, 1.0, 1.0);
				else if (cor < 25.0 )
					glColor3f(0.0, 1.0, 0.0);
				else if (cor < 45.0)
					glColor3f(1.0, 1.0, 0.0);
				else if (cor < 60.0)
					glColor3f(1.0, 0.0, 0.0);
				else
					glColor3f(1.0, 0.0, 1.0);
			} // if(cor > -20.0) 


			else {
				glColor3f(0.6, 0.6, 0.6);
			} // else
			break;
		case COR_BRILHO:
			if(cor >= -12.5) {
				cor = cor + 12.5;
				cor = cor/65;
				if (cor > 1.0)
					cor = 1.0;
				glColor3f(cor, cor, cor);
				}
			else {
				glColor3f(0.6, 0.6, 0.6);
			} // else
			break;
	}
	return;


} // void getNewColor(int i, int j)






void inciaMatriz(int argc, char *argv[]) {
	switch(argc) {


		case 1:
			matriz.setNome("dados.dat");
			break;
		case 2:
			matriz.setNome(argv[1]);
			break;
		case 3:
			matriz.setNome(argv[1]);
			matriz.setRaioInicial(argv[2]);
			break;
		default:
			exit(1);
	} // switch(argc)
	



	matriz.Faz();
	if (!strcmp("BRU", matriz.getLocal())) {
		// se for igual
		lugar = BRU;
	}
	else if (!strcmp("PPR", matriz.getLocal())) {
		// se for igual
		lugar = PPR;
	}
	else {
		lugar = UNK;
	}



} // void inciaMatriz(int argc, char *argv[]) 






/* Orgena o vetor de posies, de forma que o intervalo entre raios seja positivo, 
 * E o intervalo entre ngulos seja o menor possvel.
 * Com a selao por desenho,  teoricamente possvel mudar isso para selecionar
 * o que o usuario quiser, mas no foi implementado nessa verso. */

void ordenaVetor() {



	if(pontos[0][1] > pontos[1][1]) {
		// seta o menor raio como inicial
		unsigned int k = pontos[0][1];
		pontos[0][1] = pontos[1][1];
		pontos[1][1] = k;
	} // if(pontos[0][1] > pontos[1][1])





	// Se o raio escolhido no possuir valores
	//if (pontos[0][1] < matriz.getRaioInicial())
		//pontos[0][1] = matriz.getRaioInicial();
	//if (pontos[1][1] > matriz.getRaioFinal())
		//pontos[1][1] = matriz.getRaioFinal();
	
	


	// agora, setar o menor intervalo entre ngulos
	//de a2 para a1
	if(((360 + pontos[0][0] - pontos[1][0]) %360) <((360 + pontos[1][0] - pontos[0][0]) %360)) {
		unsigned int k = pontos[0][0];
		pontos[0][0] = pontos[1][0];
		pontos[1][0] = k;
	} // if(((360 + pontos[0][0] - pontos[1][0]) %360) <((360 + pontos[1][0] - pontos[0][0]) %360))




	abertura = (360 + pontos[1][0] - pontos[0][0])%360;


} // void ordenaVetor()





void ordenaVetorReta() {
	if (retaPontos[0][1] < matriz.getRaioInicial())
		retaPontos[0][1] = matriz.getRaioInicial();
	else if (retaPontos[0][1] > matriz.getRaioFinal())
		retaPontos[0][1] = matriz.getRaioFinal();




	if (retaPontos[1][1] < matriz.getRaioInicial())
		retaPontos[1][1] = matriz.getRaioInicial();
	else if (retaPontos[1][1] > matriz.getRaioFinal())
		retaPontos[1][1] = matriz.getRaioFinal();




	if (retaPontos[0][1] == retaPontos[1][1] && isLinha == true) {
		retaPontos[0][1] = matriz.getRaioInicial();
		retaPontos[1][1] = matriz.getRaioFinal();
		}




	if(((360 + retaPontos[0][0] - retaPontos[1][0]) %360) <((360 + retaPontos[1][0] - retaPontos[0][0]) %360)) {
		unsigned int k = retaPontos[0][0];
		retaPontos[0][0] = retaPontos[1][0];
		retaPontos[1][0] = k;
	} // if(((360 + retaPontos[0][0] - retaPontos[1][0]) %360) <((360 + retaPontos[1][0] - retaPontos[0][0]) %360))





	if (retaPontos[0][0] == retaPontos[1][0] && isLinha == false) {
		retaPontos[0][0] = 90;
		retaPontos[1][0] = 180;
		}




	// define-se os pontos do grfico a seguir




	if (isLinha == true) {
		if(retaPontos[0][1] > retaPontos[1][1]) {
			// seta o menor raio como inicial
			unsigned int k = retaPontos[0][1];
			retaPontos[0][1] = retaPontos[1][1];
			retaPontos[1][1] = k;
		} // if(retaPontos[0][1] > retaPontos[1][1]) 




		selecao[2] = retaPontos[0][0];
		



		selecao[0] = retaPontos[0][1];
		if (selecao[0] > matriz.getRaioFinal()) {
				estado = ESPERA;
		
		return;
		}



		else if (selecao[0] < matriz.getRaioInicial()) {
			selecao[0] = matriz.getRaioInicial();
		}




		selecao[1] = retaPontos[1][1];




		if (selecao[1] < matriz.getRaioInicial()) {
				estado = ESPERA;
				return;
		}
		else if (selecao[1] > matriz.getRaioFinal()) {
			selecao[1] = matriz.getRaioFinal();
		}

	} // if (isLinha == true)
	else {


		selecao[2] = retaPontos[0][1];
		if (selecao[2] > matriz.getRaioFinal() || selecao[2] < matriz.getRaioInicial() )  {
				estado = ESPERA;
				return;

		}


		selecao[0] = retaPontos[0][0];
		selecao[1] = retaPontos[1][0];

	} // else


} // void ordenaVetorReta()





/* Calcula os valores dos X e Y minimos e maximos para a projeo. Usa parmetros globais,
 * e deve ser chamado vrias vezes para que calcule os valores corretamente.
 * Em uma verso futura, essa funo pode ser fcilmente substituida por uma matematica que
 * faa o mesmo trabalho. */
void vetorDados() {


	GLfloat temp;
	for(unsigned int w = 0; w <= abertura; w++) {
		unsigned int t = pontos[0][0]+w;
		


		// faz os testes para x1
		temp = pontos[0][1]*cos(t*RADIANO)/RAIO;
		if(temp < xMin) {
			xMin = temp;
		} // if(temp < xMin)
		else if(temp > xMax) {
			xMax = temp;
		} // else if(temp > xMax)
		


		// faz os testes para x2
		temp = pontos[1][1]*cos(t*RADIANO)/RAIO;
		if(temp < xMin) {
			xMin = temp;
		} // if(temp < xMin)
		else if(temp > xMax) {
			xMax = temp;
		} // else if(temp > xMax) 
		



		// faz os testes para y1
		temp = pontos[0][1]*sin(t*RADIANO)/RAIO;
		if(temp < yMin) {
			yMin = temp;
		} // if(temp < yMin) 
		else if(temp > yMax) {
			yMax = temp;
		} // yMax = temp;
		



		// faz os testes para y2
		temp = pontos[1][1]*sin(t*RADIANO)/RAIO;
		if(temp < yMin) {
			yMin = temp;
		} // if(temp < yMin) 
		else if(temp > yMax) {
			yMax = temp;
		} // else if(temp > yMax)
	} // for(unsigned int w = 0; w <= abertura; w++)





	xIntervalo = xMax - xMin;
	yIntervalo = yMax - yMin;
	xZero = xMin + xIntervalo/2;
	yZero = yMin + yIntervalo/2;
	xMax = -2.0;
	yMax = -2.0;
	xMin = 2.0;
	yMin = 2.0;


} // void vetorDados() 




void zoomSimples(double intervalo, double xInit, double yInit) {
	xZero = xInit + intervalo/2.0;
	xMin = xInit;
	xMax = xInit + intervalo;
	yZero = yInit + intervalo/2.0;
	yMin = yInit;
	yMax = yInit + intervalo;
	escalaGlobal = 2.0/intervalo;
	xIntervalo = yIntervalo = intervalo;
}



