/******************************************************************************
 matriz.h----------------------------------------------------------------------
 Este arquivo contm a definio da classe Matriz, que  responsvel pelo
 gerenciamento da matriz de dados do arquivo.
 *****************************************************************************/









#pragma once




#include <fstream>
//#include <iostream>
#include "define.h"
#include "cidades.h"


using namespace std;







class Matriz {
	private:
		ifstream Dados; // Stream para o Arquivo de dados
		float tabela[ANGULO][RAIO]; // Tabela onde sero alocados os valores do arquivo
		float tabelaMenor2[ANGULO][RAIO/2];
		float tabelaMenor4[ANGULO][RAIO/4];






		char *nome; // Nome do arquivo de dados
		char local[4]; // Local de origem da leitura dos dados
		char data[3][3]; // Dia/Mes/Ano
		char hora[3][3]; // Horas/Minutos/Segundos
		unsigned int raioInicial; // Primeiro valor de raio da leitura
		unsigned int raioFinal; // ltimo valor de raio da leitura
		






		bool isReal(char); // Retorna verdadeiro se o nmero  Real
		bool isUnsigned(char); // Retorna verdadeiro se o nmero inteiro positivo
		float getReal(char); // Transforma uma sequencia de Stream em float. O Parmetro  o primeiro valor da Stream que  um float.
		void openDados(void); // Abre o arquivo de dados









	public:
		void setNewName(char *name, int ri, int ti, int tf); // Cria um novo nome para um arquivo de dados que ser salvo
		unsigned int raioMinimo; // Menor valor do Raio, acrescido de 4
		unsigned int raioMaximo;  // Maior valor do Raio
		unsigned int anguloMinimo; // Menor valor do ngulo
		unsigned int anguloMaximo; // Maior valor do ngulo







		Matriz(); // Construtor
		void salvaAtual(int ri, int rf, int ti, int tf); // Salva um corte como se fosse dados
		void setNome(char name[]); // Cria nome para um arquivo de dados novo
		void setRaioInicial(char name[]); // Calcula o raio inicial, baseado no nome do arquivo
		float getTabela(int angulo, int raio); // Retorna o valor de uma posio da tabela
		




		float getTabelaMenor2(int angulo, int raio);
		float getTabelaMenor4(int angulo, int raio);





		unsigned int getRaioInicial(); // Retorna o valor do Raio Inicial
		unsigned int getRaioFinal(); // Retorna o Valor do Raio Final
		char *getNome(); // Retorna o nome do arquivo
		char *getLocal(); // retonra o lugar
		char *getDia(); // retonra dia
		char *getMes(); // retonra 
		char *getAno(); // retonra 
		char *getHora(); // retonra 
		char *getMinuto(); // retonra 
		char *getSegundo(); // retonra
		





		void subMatriz2(); // construi submatriz 1000 x 360
		void subMatriz4(); // construi submatriz 500 x 360
		void Faz(); // Le o arquivo de dados e transforma em matriz de dados
};










/*******************************************************************************
 Inicio da Declarao dos Mtodos.
 *******************************************************************************/










Matriz::Matriz() {
	for (int i = 0; i < ANGULO; i++) {
		for (int j = 0; j < RAIO; j++) {
			tabela[i][j] = -26.0; // inicia matriz!
		} // for (int j = 0; j < RAIO; j++)
	} // for (int i = 0; i < ANGULO; i++)
	



	for (int i = 0; i <=2; i++) {
		for (int j = 0; j <=1; j++) {
			data[i][j] = '0';
			hora[i][j] = '0';
		} // for (int j = 0; j <=1; j++)

		data[i][2] = '\0';
		hora[i][2] = '\0';
	} // for (int i = 0; i <=2; i++)




	nome = NULL;
	raioInicial = 0;
	raioFinal = 0;
} // Matriz::Matriz() 











float Matriz::getTabela(int angulo, int raio) {
	return tabela[angulo][raio];
} // float Matriz::getTabela(int angulo, int raio) 









float Matriz::getTabelaMenor2(int angulo, int raio) {
	return tabelaMenor2[angulo][raio];
} // float Matriz::getTabela(int angulo, int raio) 









float Matriz::getTabelaMenor4(int angulo, int raio) {
	return tabelaMenor4[angulo][raio];
} // float Matriz::getTabela(int angulo, int raio) 






unsigned int Matriz::getRaioInicial() {
	return raioInicial;
} // unsigned int Matriz::getRaioInicial() 






unsigned int Matriz::getRaioFinal() {
	return raioFinal;
} // unsigned int Matriz::getRaioFinal() 







char *Matriz::getLocal() {
	return local;
} // float Matriz::getTabela(int angulo, int raio) 







char *Matriz::getDia() {
	return data[0];
}




char *Matriz::getMes() {
	return data[1];
}




char *Matriz::getAno() {
	return data[2];
}





char *Matriz::getHora() {
	return hora[0];
}





char *Matriz::getMinuto() {
	return hora[1];
}





char *Matriz::getSegundo() {
	return hora[2];
}





void Matriz::Faz() {
	iniciaCidades();
	openDados();



	// Chega no Inicio do Texto Desejado
	char cTmp = '\0', cOld = '\0';



	while ( !(cTmp == '#' && cOld == '\n')) {
		cOld = cTmp;
		Dados.get(cTmp);
	} // while ( !(cTmp == '#' && cOld == '\n'))


	
	// Agora, calcula-se o ngulo inicial.
	while (cTmp != ':') {
		Dados.get(cTmp);
	} // while (cTmp != ':')



	Dados.get(cTmp); // avana para o espao depois dos dois pontos
	char sTmp[6];


		
	Dados.get(sTmp, 6, ' ');
	float fTmp = atof(sTmp);
	


	// Gera Pontos de Parada
	int anguloInicial = (1 + (int) fTmp) % ANGULO; // Gera o grau do primeiro ponto
	int anguloFinal = ANGULO + anguloInicial;
	anguloMinimo = anguloInicial;
	raioMinimo =+raioInicial; // +4;
	


	
	cTmp = '\0';
	int t, i;
	unsigned int r = 0, wtmp = 0;
	// Comea leitura dos Valores



	for (t = anguloInicial; t < anguloFinal; t++) {
		if (Dados.eof())
					break;
		if (r > raioFinal)
			raioFinal = r-1;



		i = (t) % ANGULO; // Um valor entre 0 e 359, que equivale ao Indice I da matriz
		r = raioMinimo;
		


		// pocisionar leitura no comeo da linha de dados
		do { 
			Dados.get(cTmp);
		} while ( cTmp != '\n'); // do while ( cTmp != '\n')


		
		char lido = '0';
		


		while (lido != '#') {
			if (Dados.eof())
				break;
			Dados.get(lido);
			if (isReal(lido)) {
				tabela[i][r] = getReal(lido);
				r++;
			} // if (isReal(lido))
		} // while (lido != '#') 
		if (r > wtmp) {
			wtmp = r;
		} // if (r > wtmp)
	} // for (t = anguloInicial; t < anguloFinal; t++)
	anguloMaximo = t;
	raioMaximo = wtmp;



	subMatriz2();
	subMatriz4();


	Dados.close();
} // void Matriz::Faz()





bool Matriz::isReal(char c) {
	if ( (c >= '0' && c <= '9') || c == '.' || c == '-') {
		return true;
	} // if ( (c >= '0' && c <= '9') || c == '.' || c == '-')
	else {
		return false;
	} // else
} // bool Matriz::isReal(char c) 





bool Matriz::isUnsigned (char c) {
	if (c >= '0' && c <= '9') {
		return true;
	} // if (c >= '0' && c <= '9') 
	else {
		return false;
	} // else
}






float Matriz::getReal(char primeiro) {
	char tmp = primeiro, numero[8] = {'\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0'};
	int i = 0;
	



	do {
		numero[i] = tmp;
		i++;
		Dados.get(tmp);
	} while (isReal(tmp)); // do while (isReal(tmp))



	
	if (strcmp(numero, "--.-")) {
		float x = atof(numero);
		if (strcmp(numero, "0.0") && x == 0.0) {
			return -66.6;
		} // if (strcmp(numero, "0.0") && x == 0.0) 
		return x;
	}	
	else {
		return -27.0;
	} // else 
} // float Matriz::getReal(char primeiro)






void Matriz::openDados(void) {
	Dados.open(nome);
	if (Dados.bad()) {
		exit(1);
	} // if (Dados.bad())
} // void Matriz::openDados(void) 






void Matriz::setRaioInicial(char name[]) {
	int i = (int) strlen(name);



	while (i != -1) {
		if (!isReal(name[i])) {
			exit(1);
		} // if (!isReal(name[i])) 
		i--;
	} // while (i != -1) 


	raioInicial = atoi(name);


} // void Matriz::setRaioInicial(char name[])








/* TODO (#1#): Corrigir funo de leitura de nomes. Adicionar 
			   capacidade de extrair todos os dados do nome. */
void Matriz::setNome(char name[]) {
	int n = -1, i = 0, q = (int) strlen(name);
	char *ntemp = new char[q];

	while (name[i] != '\0') {
		if (name[i] == '\\' || name[i] == '/') {
			n = i;
		} // if (name[i] == '\\' || name[i] == '/') 
		ntemp[i] = name[i];
		i++;
	} // while (name[i] != '\0')





	++n; // garanto que n = 0 ou que n = comeo do nome do arquivo





	for (int w = n; w < q; w++) {
		ntemp[w] = '\0';
	} // for (int w = n; w < q; w++)
	




	nome = name;
	


	if (name[n+15] != '.') {
		raioInicial = 4;

		

		local[0] = name[n+0];
		local[1] = name[n+1];
		local[2] = name[n+2];
		local[3] = '\0';


		
		/* local[0] = 'U';
		local[1] = 'N';
		local[2] = 'K';
		local[3] = '\0'; */



		data[0][0] = '0';
		data[0][1] = '0';
		data[1][0] = '0';
		data[1][1] = '0';
		data[2][0] = '0';
		data[2][1] = '0';


		
		hora[0][0] = '0';
		hora[0][1] = '0';
		hora[1][0] = '0';
		hora[1][1] = '0';
		hora[2][0] = '0';
		hora[2][1] = '0';	



		return;
	} // if (name[n+15] != '.')





	if (!isUnsigned(name[n+16])) {
		raioInicial = 4;


		
		local[0] = name[n+0];
		local[1] = name[n+1];
		local[2] = name[n+2];
		local[3] = '\0';



		data[2][0] = name[n+3];
		data[2][1] = name[n+4];
		data[1][0] = name[n+5];
		data[1][1] = name[n+6];
		data[0][0] = name[n+7];
		data[0][1] = name[n+8];


		
		hora[0][0] = name[n+9];
		hora[0][1] = name[n+10];
		hora[1][0] = name[n+11];
		hora[1][1] = name[n+12];
		hora[2][0] = name[n+13];
		hora[2][1] = name[n+14];	





		return;
	} // if (!isUnsigned(name[n+16])) 
	



	// Incluir funo precisa para recolher valores da azimut e outros
	i = (int) strlen(name);
	


	// Gera o nome do lugar
	local[0] = name[n+0];
	local[1] = name[n+1];
	local[2] = name[n+2];
	local[3] = '\0';



	// 0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29
	// P  P  P  Y  Y  M  M  D  D  H  H  m  m  S  S  .  i  i  i  k "m "k  k  k  -  l  l  l "a "z
	char tmp[4] = {name[n+3] , name[n+4] , '\0', '\0'};
	data[2][0] = tmp[0];
	data[2][1] = tmp[1];
	


	tmp[0] = name[n+5];
	tmp[1] = name[n+6];
	data[1][0] = tmp[0];
	data[1][1] = tmp[1]; // mes
	


	tmp[0] = name[n+7];
	tmp[1] = name[n+8];
	data[0][0] = tmp[0];
	data[0][1] = tmp[1]; // dia
	


	tmp[0] = name[n+9];
	tmp[1] = name[n+10];
	hora[2][0] = tmp[0];
	hora[2][1] = tmp[1]; // hora

	


	tmp[0] = name[n+11];
	tmp[1] = name[n+12];
	hora[1][0] = tmp[0];
	hora[1][1] = tmp[1]; // minutos
	


	tmp[0] = name[n+13];
	tmp[1] = name[n+14];
	hora[0][0] = tmp[0];
	hora[0][1] = tmp[1]; // segundos



	int k = 16, w = 0;
	


	do {
		tmp[w++] = name[n + k++];
	} while (name[n+k] != 'k'); // do while (name[n+k] != 'k')



	tmp[w] = '\0';
	
	raioInicial = atoi(tmp)*4;
} // void Matriz::setNome(char name[]) 






void Matriz::setNewName(char *name, int xri, int xti, int xtf) {
	int i = -1, n = 0;



	while (name[n] != '\0') {
		if (name[n] == '\\' || name[n] == '/') {
			i = n;
		} // if (name[n] == '\\' || name[n] == '/') 
		n++;
	} // while (name[n] != '\0')



	++i;
	int final = (int) strlen(nome);
	final--;



	while (nome[i] != '.' && i < final) {
		name[i] = nome[i];
		i++;
	} // while (nome[i] != '.' && i < final)



	if (i == final) {
		int w = 0, xis = -1;
		char *tmp = new char[strlen(nome)+50];
		


		while (name[w] != '\0') {
			tmp[w] = name[w];
			if (name[w] == '\\' || name[w] == '/') {
				xis = w;
			} // if (name[w] == '\\' || name[w] == '/')
			w++;
		} // while (name[w] != '\0') 




		xis++;
		tmp[xis] = local[0];
		xis++;
		tmp[xis] = local[1];
		xis++;
		tmp[xis] = local[2];
		xis++;
		tmp[xis] = local[3];
		xis++;
	}




	name[i] = '.';
	i++;
	xri = xri/4;
	int k = 0;
	char tmp[4];
	sprintf(tmp, "%i", xri);



	while (tmp[k] != '\0') {
		name[i] = tmp[k];
		i++;
		k++;
	} // while (tmp[k] != '\0')



	name[i] = 'k';
	i++;
	name[i] = 'm';
	i++;
	k = 0;
	sprintf(tmp, "%i", xti);



	while (tmp[k] != '\0') {
		name[i] = tmp[k];
		i++;
		k++;
	} // while (tmp[k] != '\0') 
	


	name[i] = '-';
	i++;
	k = 0;
	sprintf(tmp, "%i", xtf);



	while (tmp[k] != '\0') {
		name[i] = tmp[k];
		i++;
		k++;
	} // while (tmp[k] != '\0') 
	name[i] = '\0';
} // void Matriz::setNewName(char *name, int xri, int xti, int xtf)







char *Matriz::getNome() {
	return nome;
} // char *Matriz::getNome()







void Matriz::salvaAtual(const int ori, const int orf, const int oti, const int otf) {
	// Gera os valores para o raio inicial e o raio final que sero impressos no nome
	// Leva em considerao em no criar uma seleo menor que a seleo inicial
	const unsigned int ri = ((unsigned)ori < raioInicial)?raioInicial:(unsigned)ori;
	const unsigned int rf = ((unsigned)orf > raioFinal)?raioFinal:(unsigned)orf;



	// Gera os valores dos ngulos azimutais da seleo
	int tit = (450-oti)%360;
	int tft = (450-otf)%360;



	if ( (360 + (tit-tft))%360 < (360 + (tft-tit))%360 ) {
		int tmp = tit;
		tit = tft;
		tft = tmp;
	} // if ( (360 + (tit-tft))%360 < (360 + (tft-tit))%360 )



	const int ti = tit, tf = tft, rit = ri;
	int x = (int) strlen(nome);
	char newName[500];
	for (int i = 0; i < x; i++)
		newName[i] = '\0';
	// Define o nome do arquivo a ser salvo
	setNewName(newName, rit, tit, tft);
	


	// Cria o arquivo
	ofstream Saida(newName);



	if (Saida.bad()) {
		exit(1);
	} // if (Saida.bad())



	// Salva o arquivo
	int tFinal = (360 + tf - ti)%360;;
	Saida << endl;
	Saida << "Raios: "  << ri << "-" << rf << "\nAngulos: " << ti << "-" << tf << "\n";
	


	for (int t = 0; t <= tFinal; t++) {
		Saida << "\n\n#  " << t << "  Az: " << (359+ti+t)%360 << " \n";
		
		for (unsigned int r = ri; r <= rf; r++) {
			if (tabela[(360+t+ti)%360][r] > -25) {
				Saida << ' ' << tabela[(360+t+ti)%360][r] << ' ';
			} // if (tabela[(360+t+ti)%360][r] > -25)
			else {
				Saida << " --.- ";
			} // else
		} // for (unsigned int r = ri+4; r <= rf; r++) 
	}
	Saida << '\n';
	

	Saida.close();
} // void Matriz::salvaAtual(const int ori, const int orf, const int oti, const int otf)







void Matriz::subMatriz2() {
	for (int k = 0; k < ANGULO; k++)
		for (int i = 0; i < RAIO; i += 2)
				tabelaMenor2[k][i/2] = max(tabela[k][i], tabela[k][i+1]);
}





void Matriz::subMatriz4() {
	for (int k = 0; k < ANGULO; k++)
		for (int i = 0; i < RAIO; i += 4)
				tabelaMenor4[k][i/4] =  max(max(tabela[k][i], tabela[k][i+1]), max(tabela[k][i+2], tabela[k][i+3]));
}




